#ifndef CPTCLIP_H
#define CPTCLIP_H

#include <stdbool.h>
#include <stddef.h>

typedef struct
{
  bool segments, verbose;
  union
  {
    struct {
      double min, max;
    } z;
    struct {
      size_t min, max;
    } segs;
  };
} cptclip_opt_t;

int cptclip(char*, char*, cptclip_opt_t);

#endif
