#ifndef GIMPSVG_H
#define GIMPSVG_H

#include <cptutils/colour.h>
#include <cptutils/svg-preview.h>

#include <stdbool.h>
#include <stdlib.h>

typedef struct
{
  bool verbose, reverse;
  size_t samples;
  double tol;
  svg_preview_t preview;
} gimpsvg_opt_t;

int gimpsvg(const char*, const char*, gimpsvg_opt_t*);

#endif
